<?php

function displayComplianceSources($records) {
  echo '
    <table width="860px">
      <tr width="100%">
        <td colspan="7">
          <br />
          <i>Associate <b>Sources</b> with this requirement</i>
          <br />
        </td>
      </tr>
      <tr class="title">
        <td width="20px"><input type="checkbox" onclick="selectAll(this.checked,\'chkCoSo\',\'btnEditSource\',\'btnRemoveSource\');" class="chk" /></td>
        <td><strong>Name</strong></td>
        <td><strong>Description</strong></td>
        <td><strong>Type</strong></td>
        <td><strong>Ref</strong>.</td>
        <td><strong>Date Issued</strong></td>
        <td><strong>Parent Source</strong></td>
      </tr>';

  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'><input type='checkbox' name='chkCoSo' value='".$record[11]."' onclick='checkStates(\"chkCoSo\",\"btnEditSource\",\"btnRemoveSource\");' class='chk' /></td>
      <td>".decodeSQL($record[3])."</td>
      <td>".decodeSQL($record[4])."</td>
      <td>".$record[7]."</td>
      <td>".$record[5]."</td>
      <td>".$record[6]."</td>
      <td>".$record[10]."</td>
    </tr>");
  }
  echo '</table>';
}

function displayAllComplianceSources($records) {
  echo '
    <table width="860px">
      <tr width="100%">
        <td colspan="7">
          <br />
          <i>Associate <b>Sources</b> with this requirement</i>
          <br />
        </td>
      </tr>
      <tr class="title">
        <td width="20px"><input type="checkbox" onclick="selectAll(this.checked,\'chkCoSo\',null,\'btnAddCompSource\');" class="chk" /></td>
        <td><strong>Name</strong></td>
        <td><strong>Description</strong></td>
        <td><strong>Type</strong></td>
        <td><strong>Ref</strong>.</td>
        <td><strong>Date Issued</strong></td>
        <td><strong>Parent Source</strong></td>
      </tr>';
  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'><input type='checkbox' name='chkCoSo' value='".$record[0]."' onclick='checkStates(\"chkCoSo\",null,\"btnAddCompSource\");' class='chk' /></td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td>".$record[5]."</td>
      <td>".$record[3]."</td>
      <td>".$record[4]."</td>
      <td>".$record[8]."</td>
    </tr>");
  }
  echo '</table>';
}

function displayAllSources($records, $addForm = 0, $addNoneParent = 0) {
  echo '
    <table width="890px">
      <tr class="title">
        <td width="20px">';
        if ($addForm == 0) {
          echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoSo\',\'btnEditSource\',\'btnRemoveSource\');" class="chk" />';
        } else {
          //TODO: Enable line below to activate Delete Source button:
          if ($addNoneParent == 0) {
            echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoSoAdd\',null,\'btnAddCompSource\'); checkStates(\'chkCoSoAdd\',null,\'btnDeleteCompSource\');" class="chk" />';
            //echo '<input type="checkbox" xonclick="selectAll(this.checked,\'chkCoSoAdd\',null,\'btnAddCompSource\');" class="chk" />';
          }
        }
  echo '</td>
        <td><strong>Name</strong></td>
        <td><strong>Description</strong></td>
        <td><strong>Type</strong></td>
        <td><strong>Ref</strong>.</td>
        <td><strong>Date Issued</strong></td>
        <td><strong>Parent Source</strong></td>
      </tr>';

  $i = 0;
  if ($addNoneParent == 1) {
    echo("<tr class='even'>");
      echo("<td width='20px'>");
        echo ("<input type='checkbox' name='chkCoSoAdd' value='0' onclick='checkStates(\"chkCoSoAdd\",\"btnAddCompSource\");checkStates(\"chkCoSoAdd\",null,\"btnDeleteCompSource\");' class='chk' />");
      echo("</td>
            <td>None</td>
            <td>Select this record to make previous source a parent.</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
         </tr>");
  }
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'>");
    if ($addForm == 0) {
      echo ("<input type='checkbox' name='chkCoSo' value='".$record[0]."' onclick='checkStates(\"chkCoSo\",\"btnEditSource\",\"btnRemoveSource\");' class='chk' />");
    } else {
      //TODO: Enable line below to activate Delete Source button:
      if ($addNoneParent == 0) {
        echo ("<input type='checkbox' name='chkCoSoAdd' value='".$record[0]."' onclick='checkStates(\"chkCoSoAdd\",null,\"btnAddCompSource\");checkStates(\"chkCoSoAdd\",null,\"btnDeleteCompSource\");' class='chk' />");
        //echo ("<input type='checkbox' name='chkCoSoAdd' value='".$record[0]."' xonclick='checkStates(\"chkCoSoAdd\",null,\"btnAddCompSource\");' class='chk' />");
      } else {
        echo ("<input type='checkbox' name='chkCoSoAdd' value='".$record[0]."' onclick='checkStates(\"chkCoSoAdd\",\"btnAddCompSource\");' class='chk' />");
      }
    }
    echo("</td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td>".$record[5]."</td>
      <td>".$record[3]."</td>
      <td>".$record[4]."</td>
      <td>".$record[8]."</td>
    </tr>");
  }
  echo '</table>';
}


function displayComplianceRisks($records) {
echo '<table width="860px">
      <tr width="100%">
        <td colspan="5">
          <br />
          <i>Associate <b>Risks</b> with this requirement</i>
          <br />
        </td>
      </tr>
      <tr class="title">
        <td width="20px"><input type="checkbox" onclick="selectAll(this.checked,\'chkCoRi\',\'btnEditRisk\',\'btnRemoveRisk\');" class="chk" /></td>
        <td><strong>Name</strong></td>
        <td><strong>Description</strong></td>
        <td><strong>Probability of Occurence (1-5)</strong></td>
        <td><strong>Impact (1 -5)</strong>.</td>
      </tr>';
  $i = 0;
  //print_r($records);
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'><input type='checkbox' name='chkCoRi' value='".$record[0]."' onclick='checkStates(\"chkCoRi\",\"btnEditRisk\",\"btnRemoveRisk\");' class='chk' /></td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td><b>".$record[3]."</b></td>
      <td><b>".$record[4]."</b></td>
    </tr>");
  }
  echo '</table>';
}

function displayAllComplianceRisks($records, $addForm = 0) {
  echo '<table width="890px">
          <tr class="title">
            <td width="20px">';
        if ($addForm == 0) {
          echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoRi\',\'btnEditRisk\',\'btnRemoveRisk\');" class="chk" />';
        } else {
          echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoRiAdd\',null,\'btnAddCompRisk\');checkStates(\'chkCoRiAdd\',null,\'btnDeleteCompRisk\');" class="chk" />';
          //echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoRiAdd\',null,\'btnAddCompRisk\');" class="chk" />';
        }
  echo '</td>
        <td><strong>Name</strong></td>
        <td><strong>Description</strong></td>
        <td><strong>Probability of Occurence (1-5)</strong></td>
        <td><strong>Impact (1 -5)</strong>.</td>
      </tr>';
  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'>");
    if ($addForm == 0) {
      echo ("<input type='checkbox' name='chkCoRi' value='".$record[0]."' onclick='checkStates(\"chkCoRi\",\"btnEditRisk\",\"btnRemoveRisk\");' class='chk' />");
    } else {
      echo ("<input type='checkbox' name='chkCoRiAdd' value='".$record[0]."' onclick='checkStates(\"chkCoRiAdd\",null,\"btnAddCompRisk\");checkStates(\"chkCoRiAdd\",null,\"btnDeleteCompRisk\");' class='chk' />");
      //echo ("<input type='checkbox' name='chkCoRiAdd' value='".$record[0]."' onclick='checkStates(\"chkCoRiAdd\",null,\"btnAddCompRisk\");' class='chk' />");
    }
    echo("</td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td><b>".$record[3]."</b></td>
      <td><b>".$record[4]."</b></td>
    </tr>");
  }
  echo '</table>';
}

function displayControls($records) {
echo '<table width="860px">
    <tr width="100%">
      <td colspan="11">
        <br />
        <i>Associate <b>Controls</b> with this requirement</i>
        <br />
      </td>
    </tr>
    <tr class="title">
      <td width="20px" rowspan="2"><input type="checkbox" value="" onclick="selectAll(this.checked,\'chkCo\',\'btnESC\',\'btnRSC\');" class="chk" /></td>
      <td rowspan="2"><strong>Name</strong></td>
      <td rowspan="2"><strong>Description</strong></td>
      <td rowspan="2"><strong>Purpose Type</strong></td>
      <td rowspan="2"><strong>Category</strong>.</td>
      <td rowspan="2"><strong>Compliance Targets</strong></td>
      <td rowspan="2"><strong>Weight</strong></td>
      <td colspan="5" style="background-color: #c0c0c0;"><center><strong>Control Component</strong></center></td>
    </tr>
    <tr style="background-color: #a6a6a6; color: white;text-align:center">
      <td title="Control Environment"><strong>CE</strong></td>
      <td title="Risk Assessment"><strong>RA</strong></td>
      <td title="Control Activities"><strong>CA</strong></td>
      <td title="Information and Communication"><strong>IC</strong></td>
      <td title="Monitoring"><strong>MO</strong></td>
    </tr>';
  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'><input type='checkbox' name='chkCo' value='".$record[0]."' onclick='checkStates(\"chkCo\",\"btnESC\",\"btnRSC\");' class='chk' /></td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td>".$record[3]."</td>
      <td>".$record[9]."</td>
      <td><b>".$record[14]."</b></td>");
    if ($record[18] != "Weight") {
      echo "<td>".str_ireplace(" ", "&nbsp;",$record[18])."</td>";
    }
    echo("
      <td>".displayYN($record[4])."</td>
      <td>".displayYN($record[5])."</td>
      <td>".displayYN($record[6])."</td>
      <td>".displayYN($record[7])."</td>
      <td>".displayYN($record[8])."</td>
    </tr>");
  }
  echo '</table>';
}

function displayAllControls($records, $addForm = 0) {
echo '<table width="890px">
    <tr class="title">
      <td width="20px" rowspan="2">';
if ($addForm == 0) {
  echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCo\',\'btnEditControl\',\'btnRemoveControl\');" class="chk" />';
} else {
  //TODO: Enable line below to activate Delete Control button:
  //echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoAdd\',null,\'btnAddCompControl\');checkStates(\'chkCoAdd\',null,\'btnDeleteCompControl\');" class="chk" />';
  echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkCoAdd\',null,\'btnAddCompControl\');" class="chk" />';
}                     //btnDeleteCompControl
echo '</td>
      <td rowspan="2"><strong>Name</strong></td>
      <td rowspan="2"><strong>Description</strong></td>
      <td rowspan="2"><strong>Purpose Type</strong></td>
      <td rowspan="2"><strong>Category</strong>.</td>
      <td rowspan="2"><strong>Compliance Targets</strong></td>
      <td rowspan="2"><strong>Weight</strong></td>
      <td colspan="5" style="background-color: #c0c0c0;"><center><strong>Control Component</strong></center></td>
    </tr>
    <tr style="background-color: #a6a6a6; color: white;text-align:center">
      <td title="Control Environment"><strong>CE</strong></td>
      <td title="Risk Assessment"><strong>RA</strong></td>
      <td title="Control Activities"><strong>CA</strong></td>
      <td title="Information and Communication"><strong>IC</strong></td>
      <td title="Monitoring"><strong>MO</strong></td>
    </tr>';
  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='20px'>");

    if ($addForm == 0) {
      echo("<input type='checkbox' name='chkCo' value='".$record[0]."' onclick='checkStates(\"chkCo\",\"btnEditControl\",\"btnRemoveControl\");' class='chk' />");
    } else {
      //TODO: Enable line below to activate Delete Control button:
      //echo("<input type='checkbox' name='chkCoAdd' value='".$record[0]."' onclick='checkStates(\"chkCoAdd\",null,\"btnAddCompControl\");checkStates(\"chkCoAdd\",null,\"btnDeleteCompControl\");' class='chk' />");
      echo("<input type='checkbox' name='chkCoAdd' value='".$record[0]."' onclick='checkStates(\"chkCoAdd\",null,\"btnAddCompControl\");' class='chk' />");
    }
    echo("    </td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td>".$record[3]."</td>
      <td>".$record[9]."</td>
      <td><b>".$record[14]."</b></td>");
    if ($record[17] != "Weight") {
      echo "<td>".str_ireplace(" ", "&nbsp;",$record[17])."</td>";
    }
    echo("
      <td>".displayYN($record[4])."</td>
      <td>".displayYN($record[5])."</td>
      <td>".displayYN($record[6])."</td>
      <td>".displayYN($record[7])."</td>
      <td>".displayYN($record[8])."</td>
    </tr>");
  }
  echo '</table>';
}

function displayYN($value) {
  $returnValue = "";
  $value = substr($value,0,1);
  if (strtoupper($value) == 'Y') {
    $returnValue = '&#8730;';
  }
  return $returnValue;
}

function displayAllComplianceTargets($records,$addForm = 0) {
echo '<table width="600px">
    <tr class="title">
      <td width="30px">';
if ($addForm == 0) {
  echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkTa\',\'btnEditControl\',\'btnRemoveControl\');" class="chk" />';
} else {
  echo '<input type="checkbox" onclick="selectAll(this.checked,\'chkTaAdd\',null,\'btnAddCompTargets\');" class="chk" />';
}
echo '</td>
      <td><strong>Compliance Target</strong></td>
      <td><strong>Description</strong></td>
      <td><strong>Type</strong></td>
    </tr>';
  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td width='30px'>");

    if ($addForm == 0) {
      echo("<input type='checkbox' name='chkTa' value='".$record[0]."' onclick='checkStates(\"chkTa\",\"btnEditControl\",\"btnRemoveControl\");' class='chk' />");
    } else {
      echo("<input type='checkbox' name='chkTaAdd' value='".$record[0]."' onclick='checkStates(\"chkTaAdd\",null,\"btnAddCompTargets\");' class='chk' />");
    }
    echo("    </td>
      <td>".decodeSQL($record[1])."</td>
      <td>".decodeSQL($record[2])."</td>
      <td>".$record[3]."</td>
    </tr>");
  }

echo '</table>';
}

function displayTargets($records) {
  echo('<select onchange="checkIfSelected()" id="selTargets" multiple="multiple" size="3" style="width: 160px;">');
  foreach($records as $record) {
    echo('<option value="'.$record[0].'">');
    echo($record[1]);
    echo('</option>');
  }
  echo('</select>');
}


function displayRules($records) {
  echo '<table width="690" style="font-size:8pt;">
         <tr class="title" style="font-weight: bold;">
           <td rowspan="2">
             Description
           </td>
           <td rowspan="2">
             Pattern
           </td>
           <td rowspan="2">
             Statement
           </td>
           <td rowspan="2" title="Formal Repr.">
             F.R.
           </td>
           <td rowspan="2" title="Design-Time">
             D.T.
           </td>
           <td rowspan="2" title="Run-Time">
             R.T.
           </td>
           <!--td rowspan="2">
             Weight
           </td-->
           <td title="Business Process Aspect Type" colspan="4" style="background-color: #c0c0c0;text-align: center;">
             B.P.A.T.
           </td>
         </tr>
         <tr class="title" style="text-align: center; font-weight: bold;">
           <td title="Control Flow">
             C.F.
           </td>
           <td title="Resource">
             Res.
           </td>
           <td title="Information">
             Inf.
           </td>
           <td title="Temporal">
             Tmp.
           </td>
         </tr>';
  $i = 0;
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
   echo("<td>".$record[1]."</td>
      <td>".$record[2]."</td>
      <td>".$record[3]."</td>
      <td>".$record[4]."</td>
      <td>".displayYN($record[5])."</td>
      <td>".displayYN($record[6])."</td>
      <!--td>".$record[7]."</td-->
      <td>".displayYN($record[7])."</td>
      <td>".displayYN($record[8])."</td>
      <td>".displayYN($record[9])."</td>
      <td>".displayYN($record[10])."</td>
    </tr>");
  }
  echo '</table>';
}

function displayTypeSelect($parentId, $selectedId=0,$width='90%',$onChange="") {
  $records = getTypeRecords($parentId);
  echo("<select id='sel".$parentId."' style='width:".$width.";' onchange='".$onChange."'>");
  if ($selectedId == 0) {
    echo("<option selected='1' value='' >&lt;Please Select&gt;</option>");
  } else {
    echo("<option value=''>&lt;Please Select&gt;</option>");
  }
  foreach($records as $record) {
    if ($record[0]==$selectedId) {
      echo("<option value='".$record[0]."' selected='1'>".$record[1]."</option>");
    } else {
      echo("<option value='".$record[0]."'>".$record[1]."</option>");
    }
  }
  echo("</select>");
}

function displayRequirements($records) {
  echo '<table style="width:860px;" class="general">
          <tr class="title">
            <td width="30">&nbsp;</td>
            <td width="415">
              Requirement Name
            </td>
            <td width="415">
              Requirement Description
            </td>
          </tr>';
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td><input type='checkbox' name='chkReq' value='".$record[0]."' onclick='checkStates(\"chkReq\",\"btnViewRequirement\");' class='chk' /></td>");

    echo("<td>".decodeSQL($record[1])."</td>
          <td>".decodeSQL($record[2])."</td>
        </tr>");
  }
  echo '</table>';

}

function displayRequirementsBySource($records) {
  echo '<table style="width:860px;" class="general">
          <tr class="title">
            <td width="30">&nbsp;</td>
            <td>
              Requirement Name
            </td>
            <td>
              Requirement Description
            </td>
            <td>
              Source Name
            </td>
            <td>
              Source Description
            </td>
            <td>
              Source Reference
            </td>
          </tr>';
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td><input type='checkbox' name='chkReq' value='".$record[0]."' onclick='checkStates(\"chkReq\",\"btnViewRequirement\");' class='chk' /></td>");

    echo("<td>".decodeSQL($record[1])."</td>
          <td>".decodeSQL($record[2])."</td>
          <td>".decodeSQL($record[3])."</td>
          <td>".decodeSQL($record[4])."</td>
          <td>".decodeSQL($record[5])."</td>
        </tr>");
  }
  echo '</table>';
}

function displayReqByRisks($records) {
  echo '<table style="width:860px;" class="general">
          <tr class="title">
            <td width="30">&nbsp;</td>
            <td>
              Requirement Name
            </td>
            <td>
              Requirement Description
            </td>
            <td>
              Risk Name
            </td>
            <td>
              Risk Description
            </td>
            <td>
              Probability
            </td>
            <td>
              Impact
            </td>
          </tr>';
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td><input type='checkbox' name='chkReq' value='".$record[9]."' onclick='checkStates(\"chkReq\",\"btnViewRequirement\");' class='chk' /></td>");

    echo("<td>".decodeSQL($record[10])."</td>
          <td>".decodeSQL($record[11])."</td>
          <td>".decodeSQL($record[1])."</td>
          <td>".decodeSQL($record[2])."</td>
          <td>".$record[3]."</td>
          <td>".$record[4]."</td>
        </tr>");
  }
  echo '</table>';
}

function displayReqByControls($records) {
  echo '<table style="width:860px;" class="general">
          <tr class="title">
            <td width="30">&nbsp;</td>
            <td>
              Requirement Name
            </td>
            <td>
              Requirement Description
            </td>
            <td>
              Control Name
            </td>
            <td>
              Control Description
            </td>
            <td>
              Purpose
            </td>
            <td>
              Category
            </td>
            <td>
              Target
            </td>
          </tr>';
  foreach($records as $record) {
    $i++; if($i>1) {$i=0;}
    if ($i==1) {
      echo("<tr class='odd'>");
    } else {
      echo("<tr class='even'>");
    }
    echo("<td><input type='checkbox' name='chkReq' value='".$record[15]."' onclick='checkStates(\"chkReq\",\"btnViewRequirement\");' class='chk' /></td>");

    echo("<td>".decodeSQL($record[16])."</td>
          <td>".decodeSQL($record[17])."</td>
          <td>".decodeSQL($record[1])."</td>
          <td>".decodeSQL($record[2])."</td>
          <td>".$record[3]."</td>
          <td>".$record[9]."</td>
          <td>".decodeSQL($record[14])."</td>
        </tr>");
  }
  echo '</table>';
}

?>