<?php
// Pull in the NuSOAP code
require_once('lib/nusoap.php');
// Create the client instance
//$client = new nusoap_client('http://localhost/eriss/http/helloworld2.php');
//$client = new nusoap_client('http://compas-ict.eu/ws/CSource?wdsl');
$client = new nusoap_client('http://compas-ict.eu/ws/CSource');
// Check for an error
$err = $client->getError();
if ($err) {
	// Display the error
	echo '<p><b>Constructor error: ' . $err . '</b></p>';
	// At this point, you know the call that follows will fail
}
// Call the SOAP method
//$result = $client->call('retrieve',array("uuid" => "dc93e0df-9c4b-49bd-8bcc-110290284f07"));
//$result = $client->call('retrieve',array("uuid" => "35b44226-3a95-438b-a9b3-1803c7a777db"));
//$result = $client->call('list',array());
//$nameSpace = array("xmlns:compas" => "http://xml.compas-ict.eu/ns/compas/0.0.3/");
$result = $client->call('retrieve',array("uuid" => "b2470802-23a1-4b66-b96e-25043408b656"));
// Check for a fault


$xml = new SimpleXMLElement($result);

//print_r($xml);
echo "<br />";
echo "Name : ";
echo $xml['name'];
echo "<br />";
echo "uuid : ";
echo $xml['uuid'];
echo "<br />";
echo "Description : ";
echo $xml['description'];
echo "<br />";
echo "csourceType : ";
echo $xml['csourceType'];
echo "<br />";
echo "Reference : ";
echo $xml['reference'];
echo "<br />";
echo "Issued On : ";
echo $xml['issuedOn'];
echo "<br />";


if ($client->fault) {
	echo '<p><b>Fault: ';
	print_r($result);
	echo '</b></p>';
} else {
	// Check for errors
	$err = $client->getError();
	if ($err) {
		// Display the error
		echo '<p><b>Error: ' . $err . '</b></p>';
	} else {
		// Display the result
    echo "<pre>";
		print_r(htmlspecialchars($result));
    echo "<br /><br />";
		print_r(($result));
    echo "<br /><br />";
		print_r(($nameSpace));
    echo "</pre>";
	}
}
// Display the request and response
echo '<h2>Request</h2>';
echo '<pre>' . htmlspecialchars($client->request, ENT_QUOTES) . '</pre>';
echo '<h2>Response</h2>';
echo '<pre>' . htmlspecialchars($client->response, ENT_QUOTES) . '</pre>';
// Display the debug messages
echo '<h2>Debug</h2>';
echo '<pre>' . htmlspecialchars($client->debug_str, ENT_QUOTES) . '</pre>';
?>
