function searchRisks() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var searchquery = document.getElementById("enterKeyword").value;
  var crId = document.getElementById("crId").value;
  var method = "POST";
  var url = "ajax/risklist.php";
  var sync = true;
  var func = searchRisksReply;
  var params = "query="+encodeURI(searchquery.toUpperCase());
  document.getElementById("riskList").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
  AjaxCall(method,url,sync,func,params,crId);
}

var searchRisksReply = function SearchRisksReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    if(response != "") {
      document.getElementById("riskList").innerHTML = response;
    } else {
//      document.getElementById("sourcesList").innerHTML = "An Error Occurred !";
    }
  }
}
var addRequestCount;
var deleteRequestCount;

function doAddCompRisk() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var chks = document.getElementsByName("chkCoRiAdd");
  var crId = document.getElementById("crId").value;
  var i;
  win.hide();
  addRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var riskId = chks[i].value;
      if (riskId != "") {
        addRiskAjax(crId,riskId);
      }
    }
  }
  // Signal done:
  domyClose();
  addRiskAjax(crId,"-1");
}

function addRiskAjax(crId,riskId) {
  var method = "POST";
  var url    = "ajax/riskadd.php";
  var sync   = true;
  var func   = addRiskReply;
  var params = "crId=" + encodeURI(crId);
  params    += "&riskId=" + riskId;
  addRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var addRiskReply = function AddRiskReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      addRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      addRiskAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      addRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Risks_list").innerHTML = aResponse[1];
      }
    }
    if (addRequestCount == 0) {
//      domyClose();
      if (aResponse[1] != "") {
        document.getElementById("Risks_list").innerHTML = aResponse[1];
      }
      checkStates("chkCoRi","btnEditRisk","btnRemoveRisk");
    }
  }
}

function doRemoveCompRisk() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var chks = document.getElementsByName("chkCoRi");
  var crId = document.getElementById("crId").value;
  var i;
  deleteRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var riskId = chks[i].value;
      if (riskId != "") {
        removeRiskAjax(crId,riskId);
      }
    }
  }
  // Signal done:
  removeRiskAjax(crId,"-1");
}

function removeRiskAjax(crId,riskId) {
  var method = "POST";
  var url    = "ajax/riskremove.php";
  var sync   = true;
  var func   = removeRiskReply;
  var params = "crId=" + encodeURI(crId);
  params    += "&riskId=" + riskId;
  deleteRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var removeRiskReply = function RemoveRiskReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      deleteRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      deleteRiskAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      deleteRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Risks_list").innerHTML = aResponse[1];
      }
    }
    if (deleteRequestCount == 0) {
      if (aResponse[1] != "") {
        document.getElementById("Risks_list").innerHTML = aResponse[1];
      }
      checkStates("chkCoRi","btnEditRisk","btnRemoveRisk");
    }
  }
}


function saveRisk() {
  if (checkIfButtonEnabled('btnAddRiskOk')) {
    var xmlHttp = CreateAjaxObject();
    if(xmlHttp == null) {
      return(false);
    }
    var crId = document.getElementById("crId").value;
    var riskId = document.getElementById("riskId").value;
    var rDescription = document.getElementById("rDescription").value;
    var rName = document.getElementById("rName").value;
    var poc = document.getElementById("sel1");
    var pocId = poc.options[poc.selectedIndex].value;
    var impact = document.getElementById("sel7");
    var impactId = impact.options[impact.selectedIndex].value;
    var method = "POST";
    var url = "ajax/risksave.php";
    var sync = true;
    var func = saveRiskReply;
    rName = encodeSQL(rName);
    rDescription = encodeSQL(rDescription);
    var params = "crId=" + encodeURI(crId) +
                 "&riskId=" + encodeURI(riskId) +
                 "&rDescription=" + encodeURI(rDescription) +
                 "&rName=" + encodeURI(rName)+
                 "&pocId=" + encodeURI(pocId) +
                 "&impactId=" + encodeURI(impactId);
    AjaxCall(method,url,sync,func,params,crId);
    domyClose();
  }
}

var saveRiskReply = function SaveRiskReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    //var aResponse = response.split("^");
    if(response != "") {
      document.getElementById("Risks_list").innerHTML = response;
    } else {
      document.getElementById("Risks_list").innerHTML = "An Error Occurred !";
    }
  }
}


function checkRisk() {
  var rName = document.getElementById("rName").value;
  var poc = document.getElementById("sel1");
  var pocId = poc.options[poc.selectedIndex].value;
  var impact = document.getElementById("sel7");
  var impactId = impact.options[impact.selectedIndex].value;
  if (pocId !="" && rName != "" && impactId!="") {
    buttonDisabledState("btnAddRiskOk",false);
  } else {
    buttonDisabledState("btnAddRiskOk",true);
  }
}


function doDeleteRisk() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var chks = document.getElementsByName("chkCoRiAdd");
  var crId = document.getElementById("crId").value;
  var i;
  deleteRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var riskId = chks[i].value;
      if (riskId != "") {
        deleteRiskAjax(crId,riskId);
      }
    }
  }
  // Signal done:
  deleteRiskAjax(crId,"-1");
}

function deleteRiskAjax(crId,riskId) {
  var method = "POST";
  var url    = "ajax/riskdelete.php";
  var sync   = true;
  var func   = deleteRiskReply;
  var params = "crId=" + encodeURI(crId);
  params    += "&riskId=" + riskId;
  deleteRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var deleteRiskReply = function DeleteRiskReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      deleteRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      deleteRiskAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      deleteRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Risks_list").innerHTML = aResponse[1];
      }
    }
    if (deleteRequestCount == 0) {
      if (aResponse[1] != "") {
        document.getElementById("Risks_list").innerHTML = aResponse[1];
      }
      //checkStates("chkCoRi","btnEditRisk","btnRemoveRisk");
    }
  }
}
