function searchSources() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var searchquery = document.getElementById("enterKeyword").value;
  var crId = document.getElementById("crId").value;
  var method = "POST";
  var url = "ajax/sourcelist.php";
  var sync = true;
  var func = searchSourcesReply;
  var params = "query="+encodeURI(searchquery.toUpperCase());
  document.getElementById("sourcesList").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
  AjaxCall(method,url,sync,func,params,crId);
}

var searchSourcesReply = function SearchSourcesReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    if(response != "") {
      document.getElementById("sourcesList").innerHTML = response;
    } else {
//      document.getElementById("sourcesList").innerHTML = "An Error Occurred !";
    }
  }
}

var addRequestCount;
var deleteRequestCount;

function doAddCompSource() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var chks = document.getElementsByName("chkCoSoAdd");
  var crId = document.getElementById("crId").value;
  var i;
  win.hide();
  addRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var sourceId = chks[i].value;
      if (sourceId != "") {
        addSourceAjax(crId,sourceId);
      }
    }
  }
  // Signal done:
  domyClose();
  addSourceAjax(crId,"-1");
}

function addSourceAjax(crId,sourceId) {
  var method = "POST";
  var url    = "ajax/sourceadd.php";
  var sync   = true;
  var func   = addSourcesReply;
  var params = "crId=" + encodeURI(crId);
  params    += "&sourceId=" + sourceId;
  addRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var addSourcesReply = function AddSourcesReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      addRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      addSourceAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      addRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Sources_list").innerHTML = aResponse[1];
      }
    }
    if (addRequestCount == 0) {
//      domyClose();
      if (aResponse[1] != "") {
        document.getElementById("Sources_list").innerHTML = aResponse[1];
      }
      checkStates("chkCoSo","btnEditSource","btnRemoveSource");
    }
  }
}

function doRemoveCompSource() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var chks = document.getElementsByName("chkCoSo");
  var crId = document.getElementById("crId").value;
  var i;
  deleteRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var sourceId = chks[i].value;
      if (sourceId != "") {
        deleteSourceAjax(crId,sourceId);
      }
    }
  }
  // Signal done:
  deleteSourceAjax(crId,"-1");
}

function deleteSourceAjax(crId,sourceId) {
  var method = "POST";
  var url    = "ajax/sourcedelete.php";
  var sync   = true;
  var func   = deleteSourcesReply;
  var params = "crId=" + encodeURI(crId);
  params    += "&sourceId=" + sourceId;
  deleteRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var deleteSourcesReply = function DeleteSourcesReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      deleteRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      deleteSourceAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      deleteRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Sources_list").innerHTML = aResponse[1];
      }
    }
    if (deleteRequestCount == 0) {
      if (aResponse[1] != "") {
        document.getElementById("Sources_list").innerHTML = aResponse[1];
      }
      checkStates("chkCoSo","btnEditSource","btnRemoveSource");
    }
  }
}

function saveSource() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var sourceId = document.getElementById('sourceId').value;
  var crId = document.getElementById("crId").value;
  var sName = document.getElementById("sName").value;
  var sDescription = document.getElementById("sDescription").value;
  var sType = document.getElementById("sel17");
  var sTypeId = sType.options[sType.selectedIndex].value;
  var sReference = document.getElementById("sReference").value;
  var sDate = document.getElementById("sourceDate").value;
  var sMainSourceId = document.getElementById("sMainSourceId").value;
  var method = "POST";
  var url = "ajax/sourcesave.php";
  var sync = true;
  var func = mysaveSourceReply;
  sName = encodeSQL(sName);
  sDescription = encodeSQL(sDescription);
  var params = "crId=" + encodeURI(crId) +
               "&sourceId=" + encodeURI(sourceId) +
               "&sName=" + encodeURI(sName) +
               "&sDescription=" + encodeURI(sDescription) +
               "&sTypeId=" + encodeURI(sTypeId) +
               "&sReference=" + encodeURI(sReference) +
               "&sDate=" + encodeURI(sDate) +
               "&sMainSourceId=" + encodeURI(sMainSourceId);
  document.getElementById("Sources_list").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
  AjaxCall(method,url,sync,func,params,crId);
}

var mysaveSourceReply = function MySaveSourceReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    if(response != "") {
      document.getElementById("Sources_list").innerHTML = response;
    } else {
      document.getElementById("Sources_list").innerHTML = "An Error Occurred !";
    }
  }
}


function doDeleteCompSource() {
  if (checkIfButtonEnabled("btnDeleteCompSource")) {
    answer = confirm("Are you sure you want to (permanently) delete the selected source(s)?");
    if (answer) {
      answer = confirm("Are you Really,\nREally,\nREAlly,\nREALly,\nREALLy,\nREALLY sure you want to (permanently) delete the selected source(s)?");
      if (answer) {
        alert("Sorry, I can't do that just yet\nMy master hasn't taught me yet...");
      }
    }
  }
}


function checkSource() {
  var sType = document.getElementById("sel17");
  var sTypeId = sType.options[sType.selectedIndex].value;
  var sName = document.getElementById("sName").value;
  if (sTypeId !="" && sName != "") {
    buttonDisabledState("btnAddSourceOk",false);
  } else {
    buttonDisabledState("btnAddSourceOk",true);
  }
}

function doSourceAsParent() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var crId = document.getElementById("crId").value;
  var sourceId = getSelectedId("chkCoSoAdd");
  if (sourceId == 0) {
    document.getElementById("sMainSourceId").value = 0;
    document.getElementById("sMainSource").value = "";
    domyClose5();
  } else {
    //var origSourceId = document.getElementById("sMainSourceId").value;
    var method = "POST";
    var url = "ajax/sourceaddparent.php";
    var sync = true;
    var func = doSourceAsParentReply;
    var params = "crId=" + encodeURI(crId) +
                 "&sourceId=" + encodeURI(sourceId);
    //document.getElementById("Sources_list").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
    AjaxCall(method,url,sync,func,params,crId);
  }
}

var doSourceAsParentReply = function DoSourceAsParentReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    response = response.replace("\r\n","");
    var aResponse = response.split("^");
    if(response != "") {
      document.getElementById("sMainSourceId").value = aResponse[0];
      document.getElementById("sMainSource").value = aResponse[1];
    } else {
//      document.getElementById("Sources_list").innerHTML = "An Error Occurred !";
    }
    domyClose5();
  }
}
