<?php
include("db.php");

fetchFromRequest("crId");

if ($crId != null) {
  $reqRecord  = getRequirement($crId);
  $CS_records = getComplianceSources($crId);
  $C_records  = getControls($crId);
  $CR_records = getComplianceRisks($crId);
}

?>
<html>
<head>
<!--link rel="STYLESHEET" type="text/css" href="codebase/dhtmlxtabbar.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/dhtmlxwindows.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/skins/dhtmlxwindows_dhx_skyblue.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/dhtmlxcalendar.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/skins/dhtmlxcalendar_simpleblue.css" /-->
<link rel="STYLESHEET" type="text/css" href="codebase/skins/dhtmlxaccordion_dhx_skyblue.css" />

<link rel="STYLESHEET" type="text/css" href="compas.css" />

<!--script type="text/javascript" src="codebase/dhtmlxtabbar.js"></script>
<script type="text/javascript" src="codebase/dhtmlxtabbar_start.js"></script>
<script type="text/javascript" src="codebase/dhtmlxcalendar.js"></script>
<script type="text/javascript" src="codebase/dhtmlxwindows.js"></script-->
<script type="text/javascript" src="codebase/dhtmlxcommon.js"></script>
<script type="text/javascript" src="codebase/dhtmlxcontainer.js"></script>
<script type="text/javascript" src="codebase/dhtmlxaccordion.js"></script>



<script type="text/javascript" src="javascript/ajax.js"></script>
<script type="text/javascript" src="javascript/ajaxsources.js"></script>
<script type="text/javascript" src="javascript/ajaxrisks.js"></script>
<script type="text/javascript" src="javascript/ajaxcontrols.js"></script>
<script type="text/javascript" src="javascript/ajaxtargets.js"></script>
<script type="text/javascript" src="javascript/ajaxrequirements.js"></script>
<script type="text/javascript" src="javascript/prototypetools.js"></script>

<script type="text/javascript">
function autoSearch(e,btnName) {
  var keynum;
  if(window.event) {
    keynum = e.keyCode;
  } else if (e.which) {
    keynum = e.which;
  }
  if (keynum == 13) {
    searchRequirements()
  }
}
</script>

</head>
<body>
<?php
  include("compas/header.php");
?>
  <center>
    <table class="pagetitle">
      <tr xstyle="background-color:#e6e6e6">
        <td xstyle="background-color:#e6e6e6">
          <strong>Search Compliance Requirements (UI-xxx)</strong>
          <br />
        </td>
    </table>

        <br />
    <table class="general">
      <tr>
        <td align="right">
          <label for="enterKeyword"><b>Enter Keyword</label>&nbsp;&nbsp;<input type="text" onkeypress="autoSearch(event,'btnSearchIt');" id="enterKeyword" style="width:550px;"/>&nbsp;&nbsp;
        </td>
        <td>
          <a class="button" href="#" onclick="this.blur(); searchRequirements(); return false;"><span>Search</span></a>
        </td>
      </tr>
    </table>
    <br />
<!--/center-->
    <div id="accordObj" style="position: relative; width: 890px; height: 500px"></div>

<script type="text/javascript">
  var dhxAccord;

  dhxAccord = new dhtmlXAccordion("accordObj");
  dhxAccord.addItem("a1","Compliance Requirements");
  dhxAccord.addItem("a2","Requirements associated with Compliance Sources");
  dhxAccord.addItem("a3","Requirements associated with Compliance Risks");
  dhxAccord.addItem("a4","Requirements associated with Controls");
  dhxAccord.setEffect(true);
  dhxAccord.cells("a1").attachURL("searchwrapper/requirementlist.php");
  dhxAccord.cells("a2").attachURL("searchwrapper/sourcelist.php");
  dhxAccord.cells("a3").attachURL("searchwrapper/risklist.php");
  dhxAccord.cells("a4").attachURL("searchwrapper/controllist.php");
  dhxAccord.openItem("a1");
</script>
</body>
</html>