function searchControls() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var searchquery = document.getElementById("enterKeyword").value;
  var useSoap = document.getElementById('useSoap').checked;
  var crId = document.getElementById("crId").value;
  var method = "POST";
  var url = "ajax/controllist.php";
  var sync = true;
  var func = searchControlsReply;
  var params = "query=" + encodeURI(searchquery.toUpperCase()) +
               "&useSoap=" + encodeURI(useSoap);
  document.getElementById("controlList").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
  AjaxCall(method,url,sync,func,params,crId);
}

var searchControlsReply = function SearchControlssReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    if(response != "") {
      document.getElementById("controlList").innerHTML = response;
    } else {
//      document.getElementById("sourcesList").innerHTML = "An Error Occurred !";
    }
  }
}

var controlAddRequestCount;
var controlDeleteRequestCount;

function doAddCompControl() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var chks = document.getElementsByName("chkCoAdd");
  var crId = document.getElementById("crId").value;
  var i;
  win.hide();
  controlAddRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var controlId = chks[i].value;
      if (controlId != "") {
        addControlAjax(crId,controlId);
      }
    }
  }
  // Signal done:
  domyClose();
  addControlAjax(crId,"-1");
}

function addControlAjax(crId,controlId) {
  var method = "POST";
  var url    = "ajax/controladd.php";
  var sync   = true;
  var func   = addControlsReply;
  var useSoap = document.getElementById('useSoap').checked;
  var params = "crId=" + encodeURI(crId);
  params    += "&controlId=" + controlId +
               "&useSoap=" + encodeURI(useSoap);
  controlAddRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var addControlsReply = function AddControlsReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      controlAddRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      addControlAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      controlAddRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Controls_list").innerHTML = aResponse[1];
      }
    }
    if (controlAddRequestCount == 0) {
//      domyClose();
      if (aResponse[1] != "") {
        document.getElementById("Controls_list").innerHTML = aResponse[1];
      }
      checkStates("chkCo","btnESC","btnRSC");
    }
  }
}

function doDeleteCompControl() {
  if (checkIfButtonEnabled('btnRSC')) {
    var xmlHttp = CreateAjaxObject();
    if(xmlHttp == null) {
      return(false);
    }
    var chks = document.getElementsByName("chkCo");
    var crId = document.getElementById("crId").value;
    var i;
    controlDeleteRequestCount = 0;
    for (i=0; i<chks.length; i++) {
      if (chks[i].checked == true) {
        var controlId = chks[i].value;
        if (controlId != "") {
          deleteControlAjax(crId,controlId);
        }
      }
    }
    // Signal done:
    deleteControlAjax(crId,"-1");
  }
}

function deleteControlAjax(crId,controlId) {
  var method = "POST";
  var url    = "ajax/controldelete.php";
  var sync   = true;
  var func   = deleteControlsReply;
  var params = "crId=" + encodeURI(crId);
  params    += "&controlId=" + controlId;
  controlDeleteRequestCount++;
  AjaxCall(method,url,sync,func,params,crId);
}

var deleteControlsReply = function DeleteControlsReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    var aResponse = response.split("^");
    if (aResponse[0].indexOf("DONE!")>=0) {
      controlDeleteRequestCount--;
    }
    if (aResponse[0].indexOf("ERROR!")>=0) {
      deleteControlAjax(crId,aResponse[1]);
    }
    if (aResponse[0].indexOf("OK!")>=0) {
      controlDeleteRequestCount--;
      if (aResponse[1] != "") {
        document.getElementById("Controls_list").innerHTML = aResponse[1];
      }
    }
    if (controlDeleteRequestCount == 0) {
//      domyClose();
      if (aResponse[1] != "") {
        document.getElementById("Controls_list").innerHTML = aResponse[1];
      }
      checkStates("chkCo","btnESC","btnRSC");
    }
  }
}

function saveControl() {
  if (checkIfButtonEnabled("createControlOk")) {
    var xmlHttp = CreateAjaxObject();
    if(xmlHttp == null) {
      return(false);
    }
    var controlId = document.getElementById('controlId').value;
    var crId = document.getElementById("crId").value;
    var sName = document.getElementById("sName").value;
    var sDescription = document.getElementById("sDescription").value;
    var sPurpose = document.getElementById("sel41");
    var sPurposeId = sPurpose.options[sPurpose.selectedIndex].value;
    var sCategory = document.getElementById("sel44");
    var sCategoryId = sCategory.options[sCategory.selectedIndex].value;
    var chkCE = document.getElementById("chk_ce").checked;
    var chkRA = document.getElementById("chk_ra").checked;
    var chkCA = document.getElementById("chk_ca").checked;
    var chkIC = document.getElementById("chk_ic").checked;
    var chkMO = document.getElementById("chk_mo").checked;
    var sWeight = document.getElementById("sel35");
    var sWeightId = sWeight.options[sWeight.selectedIndex].value;
    var method = "POST";
    var url = "ajax/controlsave.php";
    var sync = true;
    var func = saveSourceReply;
    sName = encodeSQL(sName);
    sDescription = encodeSQL(sDescription);
    var params = "crId=" + encodeURI(crId) +
                 "&controlId=" + encodeURI(controlId) +
                 "&Name=" + encodeURI(sName) +
                 "&Description=" + encodeURI(sDescription) +
                 "&PurposeId=" + encodeURI(sPurposeId) +
                 "&CategoryId=" + encodeURI(sCategoryId) +
                 "&chkCE=" + encodeURI(chkCE) +
                 "&chkRA=" + encodeURI(chkRA) +
                 "&chkCA=" + encodeURI(chkCA) +
                 "&chkIC=" + encodeURI(chkIC) +
                 "&chkMO=" + encodeURI(chkMO) +
                 "&WeightId=" + encodeURI(sWeightId);
    document.getElementById("Controls_list").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
    AjaxCall(method,url,sync,func,params,crId);
  }
}

var saveSourceReply = function SaveSourceReply(xmlHttp, crId) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    if(response != "") {
      document.getElementById("Controls_list").innerHTML = response;
    } else {
      document.getElementById("Controls_list").innerHTML = "An Error Occurred !";
    }
    domyClose();
  }
}

