function searchTargets() {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var searchquery = document.getElementById("enterKeyword").value;
  //var crId = document.getElementById("crId").value;
  var method = "POST";
  var url = "ajax/searchtargets.php";
  var sync = true;
  var func = searchTargetsReply;
  var params = "searchFor="+encodeURI(searchquery.toUpperCase());
  document.getElementById("targetsList").innerHTML = "<center><img src='/images/ajax-loader.gif' height='16' width='16' /> Processing ...</center>";
  AjaxCall(method,url,sync,func,params);
}

var searchTargetsReply = function SearchTargetsReply(xmlHttp, opt) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    if(response != "") {
      document.getElementById("targetsList").innerHTML = response;
    } else {
      document.getElementById("targetsList").innerHTML = "An Error Occurred !";
    }
  }
}

var targetAddRequestCount;

function doAddCompTargets() {
  var chks = document.getElementsByName('chkTaAdd');
  targetAddRequestCount = 0;
  for (i=0; i<chks.length; i++) {
    if (chks[i].checked == true) {
      var targetId = chks[i].value;
      if (targetId != "") {
        addTargetAjax(targetId);
      }
    }
  }
  domyCloseEvent3(); // close the window
}

function addTargetAjax(targetId) {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var controlId = document.getElementById("controlId").value;
  var crId = document.getElementById("crId").value;
  var method = "POST";
  var url = "ajax/addtargets.php";
  var sync = true;
  var func = addTargetsReply;
  var params = "controlId=" + encodeURI(controlId) +
               "&crId="     + encodeURI(crId) +
               "&targetId=" + encodeURI(targetId);
  AjaxCall(method,url,sync,func,params);
}

var addTargetsReply = function AddTargetsReply(xmlHttp, opt) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    aResponse = response.split("^");
    if(response != "") {
      document.getElementById("divSelTargets").innerHTML = aResponse[0];
      document.getElementById("Controls_list").innerHTML = aResponse[1];
    } else {
      document.getElementById("divSelTargets").innerHTML = "An Error Occurred !";
    }
    checkIfSelected();
  }
}

function doRemoveCompTargets() {
  var targets = document.getElementById('selTargets');
  var removeCount = 0;
  var targetLength = targets.length;
  var j;
  if (targetLength>1) {  // Can't remove the last target
    for (j=0; j<targetLength; j++) {
      if (targets.options[j].selected == true) {
        removeCount++;
        var targetId = targets.options[j].value;
        if (targetId != "" && removeCount < targetLength) { // Don't remove last target
          deleteTargetAjax(targetId);
        }
      }
    }
  }
}


function deleteTargetAjax(targetId) {
  var xmlHttp = CreateAjaxObject();
  if(xmlHttp == null) {
    return(false);
  }
  var controlId = document.getElementById("controlId").value;
  var crId = document.getElementById("crId").value;
  var method = "POST";
  var url = "ajax/removetargets.php";
  var sync = true;
  var func = removeTargetsReply;
  var params = "controlId=" + encodeURI(controlId) +
               "&targetId=" + encodeURI(targetId)  +
               "&crId="     + encodeURI(crId);
  AjaxCall(method,url,sync,func,params);
}

var removeTargetsReply = function RemoveTargetsReply(xmlHttp, opt) {
  if(xmlHttp.readyState == 4) {
    var response = xmlHttp.responseText;
    aResponse = response.split("^");
    if(response != "") {
      document.getElementById("divSelTargets").innerHTML = aResponse[0];
      document.getElementById("Controls_list").innerHTML = aResponse[1];
    } else {
      document.getElementById("divSelTargets").innerHTML = "An Error Occurred !";
    }
  }
  checkIfSelected();
}


function checkIfSelected() {
  var retVal = false;
  var targets = document.getElementById('selTargets');
  if (targets.length>1) {
    for (i=0; i<targets.length; i++) {
      if (targets.options[i].selected == true) {
        retVal = true;
        i = targets.length;
      }
    }
  }
  buttonDisabledState("btnRemoveTarget",!retVal);
}
