<?php
include("db.php");

fetchFromRequest("crId");

if ($crId != null) {
  $reqRecord  = getRequirement($crId);
  $CS_records = getComplianceSources($crId);
  $C_records  = getControls($crId);
  $CR_records = getComplianceRisks($crId);
}

?>

<link rel="STYLESHEET" type="text/css" href="codebase/dhtmlxtabbar.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/dhtmlxwindows.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/skins/dhtmlxwindows_dhx_skyblue.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/dhtmlxcalendar.css" />
<link rel="STYLESHEET" type="text/css" href="codebase/skins/dhtmlxcalendar_simpleblue.css" />

<link rel="STYLESHEET" type="text/css" href="compas.css" />

<script type="text/javascript" src="codebase/dhtmlxcommon.js"></script>
<script type="text/javascript" src="codebase/dhtmlxtabbar.js"></script>
<script type="text/javascript" src="codebase/dhtmlxtabbar_start.js"></script>
<script type="text/javascript" src="codebase/dhtmlxwindows.js"></script>
<script type="text/javascript" src="codebase/dhtmlxcontainer.js"></script>
<script type="text/javascript" src="codebase/dhtmlxcalendar.js"></script>


<script type="text/javascript" src="javascript/ajax.js"></script>
<script type="text/javascript" src="javascript/ajaxsources.js"></script>
<script type="text/javascript" src="javascript/ajaxrisks.js"></script>
<script type="text/javascript" src="javascript/ajaxcontrols.js"></script>
<script type="text/javascript" src="javascript/ajaxtargets.js"></script>
<script type="text/javascript" src="javascript/ajaxrequirements.js"></script>
<script type="text/javascript" src="javascript/prototypetools.js"></script>
<script type="text/javascript">
  dhtmlx.skin = "modern";
  window.dhx_globalImgPath = "codebase/imgs/"; //calendar specific
</script>
<center>

<?php
  include("compas/header.php");
  echo '<input type="hidden" id="crId" value="'.$reqRecord[0].'" />';
?>
  <div id="winVP">
  <table class="pagetitle">
    <tr style="background-color:#e6e6e6">
      <td colspan="2" style="background-color:#e6e6e6">
        <strong>Compliance Requirement (UI-200)</strong>
        <br />
      </td>
      <td style="background-color:#e6e6e6;text-align:right;font-size:12;">
        <b><label for="useSoap">Use SOAP</label></b><input type="checkbox" id="useSoap" class="chk" />
        <br />
      </td>
    </tr>
  </table>
  <table width="890px" style="font-family:arial;font-size:12">
    <tr>
      <td width="50%">
        <fieldset>
          <legend>
            <span style="font-size:14"><b>Requirement:</b></span>
          </legend>
<?php
          echo("<textarea class='box' xstyle='width:100%;font-size:11;' id='requirement' lines='4' onkeyup='checkRequirementData();'>".decodeSQL($reqRecord[1])."</textarea>");
?>
        </fieldset>
      </td>
      <td width="50%">
        <fieldset>
          <legend>
            <span style="font-size:14"><b>Description:</b></span>
          </legend>
<?php
          echo("<textarea class='box' xstyle='width:100%;font-size:11' id='req_description' lines='4' onkeyup='checkRequirementData();' >".decodeSQL($reqRecord[2])."</textarea>");
?>
        </fieldset>
      </td>
    </tr>
  </table>
<?php
if ($reqRecord[0] == "") {
  echo '<div id="CRdetails" style="display:none">';
} else {
  echo '<div id="CRdetails">';
}
?>

    <table class="general">
      <tr >
        <td>
          <div id="a_tabbar" class="dhtmlxTabBar" imgpath="codebase/imgs/" style="width:100%;height:600px;overflow:auto;">
            <div id="a1" name="Comp.Sources" class="tab">
              <div id="Sources_list" class='list'>
  <?php
      displayComplianceSources($CS_records);
  ?>
              </div>
              <table class="general">
                <tr>
                  <td colspan="2">&nbsp;</td>
                </tr>
                <tr>
                  <td width="40%">
  <?php
  echo '<a class="button" id="btnAddSource"    href="#" onclick="this.blur();addSource('.$crId.'); return false;"><span>Add Source</span></a>';
  echo '<a class="button" id="btnCreateSource" href="#" onclick="this.blur();createSource(1); return false;"><span>Create New</span></a>';
  //                  echo '<input id="btnAddSource" type="button" value="Add Source" onclick="addSource('.$crId.')" />';
  //                  echo ' <input id="btnCreateSource" type="button" value="Create New" onclick="createSource();" />';
  ?>
                  </td>
                  <td width="60%">
          <a class="buttondisabled" id="btnEditSource" href="#" onclick="this.blur();editSelectedSource(null); return false;"><span>Edit&nbsp;Selected</span></a>
          <a class="buttondisabled" id="btnRemoveSource" href="#" onclick="this.blur();doRemoveCompSource(); return false;"><span>Remove&nbsp;Selected</span></a>
  <!--
                    <input id="btnEditSource"   type="button" value="Edit Selected"   disabled="1" />
                    <input id="btnRemoveSource" type="button" value="Remove Selected" disabled="1" onclick="doDeleteCompSource();" />
  -->
                  </td>
                </tr>
              </table>
            </div>

  <!--
    -->
            <div id="a2" name="Comp.Risks"  class="tab">
              <div id="Risks_list" class="list" >
  <?php
      displayComplianceRisks($CR_records);
  ?>
              </div>
              <table class="general">
                <tr>
                  <td colspan="2">&nbsp;</td>
                </tr>
                <tr>
                  <td width="40%">
  <?php
  echo '<a class="button" id="btnAddRisk"    href="#" onclick="this.blur();addRisk('.$crId.'); return false;"><span>Add Risk</span></a>';
  echo '<a class="button" id="btnCreateRisk" href="#" onclick="this.blur();createRisk(1);     return false;"><span>Create New</span></a>';

  // echo '           <input id="btnAddRisk"    type="button" value="Add Risk"   onclick="addRisk('.$crId.')"  />';
  // echo '           <input id="btnCreateRisk" type="button" value="Create New" onclick="createRisk('.$crId.')"/>';
  ?>
                  </td>
                  <td width="60%">
          <a class="buttondisabled" id="btnEditRisk" href="#" onclick="this.blur(); editSelectedRisk(null);return false;"><span>Edit&nbsp;Selected</span></a>
          <a class="buttondisabled" id="btnRemoveRisk" href="#" onclick="this.blur();doRemoveCompRisk(); return false;"><span>Remove&nbsp;Selected</span></a>
  <!--
                    <input id="btnEditRisk"   type="button" value="Edit Selected"   disabled="1" />
                    <input id="btnRemoveRisk" type="button" value="Remove Selected" disabled="1" onclick="doDeleteCompRisk();" />
  -->
                  </td>
                </tr>
              </table>
            </div>

  <!--
    -->
            <div id="a3" name="Controls"  class="tab">
              <div id="Controls_list" class="list">
  <?php
      displayControls($C_records);
  ?>
              </div>
              <table class="general">
                <tr>
                  <td colspan="2">&nbsp;</td>
                </tr>
                <tr>
                  <td width="40%">
  <?php
  //echo '            <input id="btnAddControl"    type="button" value="Add Control" onclick="addControl('.$crId.')" />';
  //echo '            <input id="btnCreateControl" type="button" value="Create New"  onclick="createControl(-1)"/>';
  echo '<a class="button" id="btnAddControl"    href="#" onclick="this.blur();addControl('.$crId.'); return false;"><span>Add Control</span></a>';
  echo '<a class="button" id="btnCreateControl" href="#" onclick="this.blur();createControl(-1); return false;"><span>Create New</span></a>';
  ?>
                  </td>
                  <td width="60%">
          <a class="buttondisabled" id="btnESC" href="#" onclick="this.blur();editSelectedControl(); return false;"><span>Edit&nbsp;Selected</span></a>
          <a class="buttondisabled" id="btnRSC" href="#" onclick="this.blur();doDeleteCompControl(); return false;"><span>Remove&nbsp;Selected</span></a>
  <!--
                    <input id="btnEditControl"   type="button" value="Edit Selected"   disabled="1" onclick="createControl()" />
                    <input id="btnRemoveControl" type="button" value="Remove Selected" disabled="1" onclick="doDeleteCompControl();" />
  -->
                  </td>
                </tr>
              </table>
            </div>
          </div>
        </td>
      </tr>
    </table>
  </div>
  <table class="general">
    <tr>
      <td>
    <div style="width: 890px;">
<!--
        <input id="btnCancel" type="button" value="Cancel" />
        <input id="btnSave"   type="button" value="Save"   />
-->
        <a class="button" href="#" onclick="this.blur(); window.location.assign('searchrequirements.php'); return false;"><span>Close</span></a>
        <a class="buttondisabled" id="btnSaveReq" href="#" onclick="this.blur();saveRequirement(); return false;"><span>Save</span></a>
    </div>
      </td>
    </tr>
  </table>
</center>
</div>

<!--
<script type="text/javascript">
tabbar = new dhtmlXTabBar("a_tabbar", "top");
tabbar.setSkin('dhx_skyblue');
tabbar.setImagePath("codebase/imgs/");
tabbar.addTab("ha1", "Tab 1-1", "100px");
tabbar.addTab("ha2", "Tab 1-2", "100px");
tabbar.addTab("ha3", "Tab 1-3", "100px");
tabbar.setContent("ha1", "a1");
tabbar.setContent("ha2", "a2");
tabbar.setContent("ha3", "a3");

</script>
-->
<?php
if ($reqRecord[0] == "") {
  echo '<script type="text/javascript">';
  echo '  document.getElementById("requirement").focus();';
  echo '</script>';
}
?>